/*
local
	barra iBarraOrigen;
	barra iBarraDestino;
end
*/

//--------------------------------------------------------------------------------------
function byte Copiar(string sDirDestino);
// Funcin que copia los ficheros seleccionados a sDirDestino.
// Devuelve '1' xito, '0' error.

private
	int iContador=0;
	byte bResultado=0;
	string sFicheroOrigen;
	string sFicheroDestino;
	string sMensajeOrigen[1];
	string sMensajeDestino[1];
	string sArchivo;
	string sDirectorio="";
	int iVentanaProgresoCopia=0;

	int iContador2=0;
	string sDirectorioDestino;
	string sDirectorioOrigen;
	byte bExiste=0;
	//Datos fichero origen.
	string sFilenameOrigen="";
	int iSizeOrigen=0;
	string sCreatedOrigen="";
	//Datos fichero Destino.
	string sFilenameDestino="";
	int iSizeDestino=0;
	string sCreatedDestino="";
	string sTrozos[9]; //Contiene el directorio desmembrado.
	int iTrozos=0;
	string sDirTemporal;
	int iTamanoACopiar=0;
	dword dCien=100;
	string sBarra="";
end

begin
	sDirectorioDestino=sDirDestino;
	sDirectorioOrigen=sDirectorioEnCurso+pDirectorio[iContador].name
						+"."+sDirectorioEnCurso+pDirectorio[iContador].ext+chBarra;
	signal(ALL_PROCESS,s_freeze);
	dValorParcialDestino=0;
	//Si no hay nada que copiar, retorno 0.
	if (((pdirectorio[(Puntero+primerArchivo)].Name==".")or(pdirectorio[(Puntero+primerArchivo)].Name==".."))and
		iArchivosSeleccionados==0 and iDirectoriosSeleccionados==0)
		signal(ALL_PROCESS,s_wakeup);
		return 0;
	end
	// Hay algo que copiar.
	bQueHacerSiExiste=0;
	bAbortar=0;
	sMensajeOrigen[0]="Error en fichero origen: ";
	sMensajeOrigen[1]=sFicheroOrigen;
	sMensajeDestino[0]="Error en fichero destino: ";
	sMensajeDestino[1]=sFicheroDestino;

	
	//Abrimos una ventana de progreso de copia.
	iVentanaProgresoCopia=VentanaProgresoCopia(0,0,0,0,0,iDrawingZZ,iTextZ);
	sProgresoOrigen="Prueba Origen";
	sProgresoDestino="Total:";
	iVentanaProgresoCopia.bRepintar=1;
	while (iVentanaProgresoCopia.bRepintar==1)
		frame;
	end
	while (!exists(iBarraOrigen))
		frame;
	end
	dValorOrigen=0;
	dValorDestino=0;
	if (iArchivosSeleccionados>0 or iDirectoriosSeleccionados>0) //Si hay algn archivo seleccionado.
		dValorTotalDestino=iTotalKbSeleccionados*1024;
		if (dValorTotalDestino==0)
			dValorTotalDestino=1024;
		end
		iContador=0;
		while (iContador<n_Archivos and !bAbortar)
			if (pDirectorio[iContador].selected)	// Si est seleccionado.
				if(!pDirectorio[iContador].directory)// Si es un archivo.
//*************
					sProgresoOrigen=pDirectorio[iContador].name+"."+pDirectorio[iContador].ext;
					iSizeOrigen=pDirectorio[iContador].size;
					sCreatedOrigen=fileinfo.modified;
					bExiste=MiFexists(sDirectorioDestino,sProgresoOrigen);
					if (bExiste)
						sCreatedDestino=fileinfo.modified;
						iSizeDestino=fileinfo.size;
					end
					if (bExiste==0)
						if(!CopiaFicheroConBuffer(sDirectorioEnCurso+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext,
							sDirDestino+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext))
							//Error copiando fichero. Aborto.
							cd(sDirectorioEnCurso);
							bAbortar=0;
						end
					else
						if (bQueHacerSiExiste==0)
							// El fichero existe, pero no se lo que hay que hacer. Pregunto que hago.
							//1 - Overwrite
							//2 - Overwrite all
							//3 - Overwrite all older
							//4 - Skip
							//5 - Skip all
							//6 - Cancel
							bQueHacerSiExiste=VentanaFicheroExiste(
												sDirectorioEnCurso,
												sFilenameOrigen,
												iToS(iSizeOrigen)+" bytes, "+sCreatedOrigen,
												sDirectorioDestino,
												sFilenameOrigen,
												iToS(iSizeDestino)+" bytes, "+sCreatedDestino);
							// Con la respuesta miro lo que hago.
						end
						switch (bQueHacerSiExiste)
							case 1:
								//1 - Overwrite
								if(!CopiaFicheroConBuffer(sDirectorioEnCurso+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext,
									sDirDestino+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext))
									//Error copiando fichero. Aborto.
									cd(sDirectorioEnCurso);
									bAbortar=0;
								end
								bQueHacerSiExiste=0; //Para volver a preguntar.
							end
							case 2:
								//1 - Overwrite all.
								if(!CopiaFicheroConBuffer(sDirectorioEnCurso+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext,
									sDirDestino+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext))
									//Error copiando fichero. Aborto.
									cd(sDirectorioEnCurso);
									bAbortar=0;
								end
							end
							case 3:
								//3 - Overwrite all older
								if (sCreatedOrigen>sCreatedDestino)
									if(!CopiaFicheroConBuffer(sDirectorioEnCurso+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext,
										sDirDestino+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext))
										//Error copiando fichero. Aborto.
										cd(sDirectorioEnCurso);
										bAbortar=0;
									end
								end
							end
							case 4:
								//4 - Skip
								bQueHacerSiExiste=0; //Para volver a preguntar.
								dValorParcialDestino=dValorParcialDestino+pDirectorio[iContador].size;
								if(dValorParcialDestino>1024 and dValorTotalDestino>1024)
									dValorDestino=((dValorParcialDestino/1024)*dcien/(dValorTotalDestino/1024));
								else
									dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
								end
							end
							case 5:
								//5 - Skip all
								//No hago nada. Salto si el fichero existe.
								dValorParcialDestino=dValorParcialDestino+pDirectorio[iContador].size;
								if(dValorParcialDestino>1024 and dValorTotalDestino>1024)
									dValorDestino=((dValorParcialDestino/1024)*dcien/(dValorTotalDestino/1024));
								else
									dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
								end
							end
							case 6:
								//6 - Cancel
								bAbortar=1;
								return 0;
							end
						end
					end
				else	// Es un directorio.
					if (pDirectorio[Puntero+primerArchivo].ext=="")
						if(!CopiaDirectorio(sDirectorioEnCurso+pDirectorio[iContador].name+chBarra,
							sDirDestino))
							//Error copiando fichero. Aborto.
							cd(sDirectorioEnCurso);
							bAbortar=0;
						end
					else
						if(!CopiaDirectorio(sDirectorioEnCurso+pDirectorio[iContador].name
						+"."+pDirectorio[iContador].ext+chBarra,
							sDirDestino))
							//Error copiando fichero. Aborto.
							cd(sDirectorioEnCurso);
							bAbortar=0;
						end
					end
				end
			end
			frame;
			iContador++;
		end
	else //Si no hay ningn archivo seleccionado copio el actual.
		if(!pDirectorio[(Puntero+primerArchivo)].directory)// Si es un archivo.
//*****	
			dValorTotalDestino=pDirectorio[(Puntero+primerArchivo)].size;
			if (dValorTotalDestino==0)
				dValorTotalDestino=1;
			end

			sProgresoOrigen=pdirectorio[(Puntero+primerArchivo)].Name+"."+
										pdirectorio[(Puntero+primerArchivo)].Ext;
			frame;
			sFilenameOrigen=sProgresoOrigen;
			iSizeOrigen=pdirectorio[(Puntero+primerArchivo)].size;
			sCreatedOrigen=fileinfo.modified;
			bExiste=MiFexists(sDirectorioDestino,sFilenameOrigen);
			if (bExiste)
				sCreatedDestino=fileinfo.modified;
				iSizeDestino=fileinfo.size;
			end
			if (bExiste==0)
				if(!CopiaFicheroConBuffer(sDirectorioEnCurso+
										pdirectorio[(Puntero+primerArchivo)].Name+"."+
										pdirectorio[(Puntero+primerArchivo)].Ext,
										sDirDestino+
										pdirectorio[(Puntero+primerArchivo)].Name+"."+
										pdirectorio[(Puntero+primerArchivo)].Ext))
					//Error copiando fichero. Aborto.
					cd(sDirectorioEnCurso);
					bAbortar=0;
				end
			else
				if (bQueHacerSiExiste==0)
					// El fichero existe, pero no se lo que hay que hacer. Pregunto que hago.
					//1 - Overwrite
					//2 - Overwrite all
					//3 - Overwrite all older
					//4 - Skip
					//5 - Skip all
					//6 - Cancel
					bQueHacerSiExiste=VentanaFicheroExiste(
										sDirectorioEnCurso,
										sFilenameOrigen,
										iToS(iSizeOrigen)+" bytes, "+sCreatedOrigen,
										sDirectorioDestino,
										sFilenameOrigen,
										iToS(iSizeDestino)+" bytes, "+sCreatedDestino);
					// Con la respuesta miro lo que hago.
				end
				switch (bQueHacerSiExiste)
					case 1:
						//1 - Overwrite
						if(!CopiaFicheroConBuffer(sDirectorioEnCurso+
												pdirectorio[(Puntero+primerArchivo)].Name+"."+
												pdirectorio[(Puntero+primerArchivo)].Ext,
												sDirDestino+
												pdirectorio[(Puntero+primerArchivo)].Name+"."+
												pdirectorio[(Puntero+primerArchivo)].Ext))
							//Error copiando fichero. Aborto.
							cd(sDirectorioEnCurso);
							bAbortar=0;
						end
						bQueHacerSiExiste=0; //Para volver a preguntar.
					end
					case 2:
						//1 - Overwrite all.
						if(!CopiaFicheroConBuffer(sDirectorioEnCurso+
												pdirectorio[(Puntero+primerArchivo)].Name+"."+
												pdirectorio[(Puntero+primerArchivo)].Ext,
												sDirDestino+
												pdirectorio[(Puntero+primerArchivo)].Name+"."+
												pdirectorio[(Puntero+primerArchivo)].Ext))
							//Error copiando fichero. Aborto.
							cd(sDirectorioEnCurso);
							bAbortar=0;
						end
					end
					case 3:
						//3 - Overwrite all older
						if (sCreatedOrigen>sCreatedDestino)
							if(!CopiaFicheroConBuffer(sDirectorioEnCurso+
													pdirectorio[(Puntero+primerArchivo)].Name+"."+
													pdirectorio[(Puntero+primerArchivo)].Ext,
													sDirDestino+
													pdirectorio[(Puntero+primerArchivo)].Name+"."+
													pdirectorio[(Puntero+primerArchivo)].Ext))
								//Error copiando fichero. Aborto.
								cd(sDirectorioEnCurso);
								bAbortar=0;
							end
						end
					end
					case 4:
						//4 - Skip
						bQueHacerSiExiste=0; //Para volver a preguntar.
						dValorParcialDestino=dValorParcialDestino+pdirectorio[(Puntero+primerArchivo)].size;
						dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
					end
					case 5:
						//5 - Skip all
						//No hago nada. Salto si el fichero existe.
						dValorParcialDestino=dValorParcialDestino+pdirectorio[(Puntero+primerArchivo)].size;
						dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
					end
					case 6:
						//6 - Cancel
						bAbortar=1;
						return 0;
					end
				end
			end
		dValorTotalDestino=pDirectorio[(Puntero+primerArchivo)].size;
			if (dValorTotalDestino==0)
				dValorTotalDestino=1;
			end
		else	// Es un directorio. Lo copio si no es .. o .
			if ((pdirectorio[(Puntero+primerArchivo)].Name!=".")and(pdirectorio[(Puntero+primerArchivo)].Name!=".."))
				dValorTotalDestino=CalculaSizeDirectorio(sDirectorioEnCurso+pdirectorio[(Puntero+primerArchivo)].Name+chBarra);
				if (dValorTotalDestino==0)
					dValorTotalDestino=1;
				end
				if (pDirectorio[Puntero+primerArchivo].ext=="")
					if(!CopiaDirectorio(sDirectorioEnCurso+
										pdirectorio[(Puntero+primerArchivo)].Name+chBarra,
										sDirDestino))
						//Error copiando fichero. Aborto.
						cd(sDirectorioEnCurso);
						bAbortar=0;
					end
				else
					if(!CopiaDirectorio(sDirectorioEnCurso+
										pdirectorio[(Puntero+primerArchivo)].Name
										+"."+pdirectorio[(Puntero+primerArchivo)].ext+chBarra,
										sDirDestino))
						//Error copiando fichero. Aborto.
						cd(sDirectorioEnCurso);
						bAbortar=0;
					end
				end
			end
		end
	end
	frame;
	if (exists(iVentanaProgresoCopia))
		signal(iVentanaProgresoCopia,s_Kill_tree);
	end
	frame;
	signal(ALL_PROCESS,s_wakeup);
	return 1;
end
		
//--------------------------------------------------------------------------------------
function byte CopiaDirectorio(string sDirectorioOrigen, string sDirectorioDestino)
//Copia recursivamente un directorio.
// Devuelve '1' xito, '0' error.
private
	string sArchivo;
	string sDirectorioEnCurso;
	int iContador; //N de la entrada que vamos procesando.
	int iContador2; //N contador temporarl hasta llegar a la entrada a procesar.
	byte bResultado=0; //Resultados parciales de la copia de un fichero.
	byte bExiste=0;
	//Datos fichero origen.
	string sFilenameOrigen="";
	int iSizeOrigen=0;
	string sCreatedOrigen="";
	//Datos fichero Destino.
	string sFilenameDestino="";
	int iSizeDestino=0;
	string sCreatedDestino="";
	string sTrozos[9]; //Contiene el directorio desmembrado.
	int iTrozos=0;
	string sDirTemporal;
	int iTamanoACopiar=0;
	dword dCien=100;
	string sBarra="";

end


begin
	if (os_id==os_win32)
		sBarra="\\";
	else
		sBarra=chBarra;
	end
	iTrozos=split(sBarra,sDirectorioOrigen,&sTrozos,9);
	sDirectorioDestino=sDirectorioDestino+sTrozos[iTrozos-2]+chBarra;
	mkDir(sDirectorioDestino);
	sDirectorioEnCurso=cd()+chBarra;
	cd(sDirectorioOrigen);
	sArchivo=glob("");
	sArchivo=glob("*.*");
	while (sArchivo!="" and bAbortar==0)
		iContador++;
		if ((fileinfo.directory)and(fileinfo.name!=".")and(fileinfo.name!=".."))
			//Es un directorio.
			cd(fileinfo.name);
			iContador2=0;
			if (!CopiaDirectorio(cd()+chBarra,sDirectorioDestino))
				cd(sDirectorioEnCurso);
				return 0;
			end
			cd("..");
			sArchivo=glob("");
			sArchivo=glob("*.*");
			//Vuelvo a posicionar el puntero en su sitio.
			while (iContador2<iContador)
				sArchivo=glob("*.*");
				iContador2++;
			end
		else
			if (!fileinfo.directory)

				sProgresoOrigen=fileinfo.name;
				frame;
				sFilenameOrigen=fileinfo.name;
				iSizeOrigen=fileinfo.size;
				sCreatedOrigen=fileinfo.modified;
				bExiste=MiFexists(sDirectorioDestino,fileinfo.name);
				if (bExiste)
					sCreatedDestino=fileinfo.modified;
					iSizeDestino=fileinfo.size;
				end
				iContador2=0;
				sArchivo=glob("");
				sArchivo=glob("*.*");
				//Vuelvo a posicionar el puntero en su sitio.
				while (iContador2<iContador)
					sArchivo=glob("*.*");
					iContador2++;
				end
				if (bExiste==0)
					if(!CopiaFicheroConBuffer(sDirectorioOrigen+sFilenameOrigen,sDirectorioDestino+sFilenameOrigen))
						//Error copiando fichero. Aborto.
						cd(sDirectorioEnCurso);
						return 0;
					end
				else
					if (bQueHacerSiExiste==0)
						// El fichero existe, pero no se lo que hay que hacer. Pregunto que hago.
						//1 - Overwrite
						//2 - Overwrite all
						//3 - Overwrite all older
						//4 - Skip
						//5 - Skip all
						//6 - Cancel
						bQueHacerSiExiste=VentanaFicheroExiste(
											sDirectorioEnCurso,
											sFilenameOrigen,
											iToS(iSizeOrigen)+" bytes, "+sCreatedOrigen,
											sDirectorioDestino,
											sFilenameOrigen,
											iToS(iSizeDestino)+" bytes, "+sCreatedDestino);
						// Con la respuesta miro lo que hago.
					end
					switch (bQueHacerSiExiste)
						case 1:
							//1 - Overwrite
							if(!CopiaFicheroConBuffer(sDirectorioOrigen+sFilenameOrigen,sDirectorioDestino+sFilenameOrigen))
								//Error copiando fichero. Aborto.
								cd(sDirectorioEnCurso);
								return 0;
							end
							bQueHacerSiExiste=0; //Para volver a preguntar.
						end
						case 2:
							//1 - Overwrite all.
							if(!CopiaFicheroConBuffer(sDirectorioOrigen+sFilenameOrigen,sDirectorioDestino+sFilenameOrigen))
								//Error copiando fichero. Aborto.
								cd(sDirectorioEnCurso);
								return 0;
							end
						end
						case 3:
							//3 - Overwrite all older
							if (sCreatedOrigen>sCreatedDestino)
								if(!CopiaFicheroConBuffer(sDirectorioOrigen+sFilenameOrigen,sDirectorioDestino+sFilenameOrigen))
									//Error copiando fichero. Aborto.
									cd(sDirectorioEnCurso);
									return 0;
								end
							end
						end
						case 4:
							//4 - Skip
							bQueHacerSiExiste=0; //Para volver a preguntar.
							dValorParcialDestino=dValorParcialDestino+fileinfo.size;
							if(dValorParcialDestino>1024 and dValorTotalDestino>1024)
								dValorDestino=((dValorParcialDestino/1024)*dcien/(dValorTotalDestino/1024));
							else
								dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
							end
						end
						case 5:
							//5 - Skip all
							//No hago nada. Salto si el fichero existe.
							dValorParcialDestino=dValorParcialDestino+fileinfo.size;
							if(dValorParcialDestino>1024 and dValorTotalDestino>1024)
								dValorDestino=((dValorParcialDestino/1024)*dcien/(dValorTotalDestino/1024));
							else
								dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
							end
						end
						case 6:
							//6 - Cancel
							bAbortar=1;
							return 0;
						end
					end
				end

			else
				sArchivo=glob("*.*");
			end
		end

		//frame;
	end;
	chdir(sDirectorioEnCurso);
	return 1;
end
//--------------------------------------------------------------------------------------
function byte CopiaFicheroConBuffer(string sFicheroOrigen, string sFicheroDestino)
// Copia UN fichero a su destino.
// Devuelve '1' xito, '0' error.
private
	byte pointer pbBuffer;
	int iTamanoBuffer;
	int iIdeFicheroOrigen;
	int iTamanoFicheroOrigen;
	int iIdeFicheroDestino;
	int iTamanoTrozo;
	int iLongRead=0;
	int iLongWrite=0;
	string sMensajeOrigen[1];
	string sMensajeDestino[1];
	dword dcien=100;
end
begin
	iValor=0; // Por donde vamos leyendo/escribiendo. Variable para ser leida fuera del proceso.
	sMensajeOrigen[0]="Error abriendo fichero origen: ";
	sMensajeOrigen[1]=sFicheroOrigen;
	sMensajeDestino[0]="Error abriendo fichero destino: ";
	sMensajeDestino[1]=sFicheroDestino;
	iIdeFicheroOrigen=fopen(sFicheroOrigen,o_read);
	if (iIdeFicheroOrigen==0)
		VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error");
		return 0;
	end
	iIdeFicheroDestino=fopen(sFicheroDestino,o_write);
	if (iIdeFicheroDestino==0)
		VentanaMensaje(0,0,0,0,0,&sMensajeDestino,2,"Error");
		return 0;
	end
	sMensajeOrigen[0]="Error leyendo fichero origen: ";
	sMensajeOrigen[1]=sFicheroOrigen;
	sMensajeDestino[0]="Error escribiendo fichero destino: ";
	sMensajeDestino[1]=sFicheroDestino;
	iTamanoFicheroOrigen=flength(iIdeFicheroOrigen);
	//Dependiendo del tamao del fichero lo leeremos a diferentes trozos.
	iTamanoTrozo=iTamanoFicheroOrigen/10;
	if (iTamanoTrozo<100000) //Menor de 100k lo leo del tiron y lo escribo del tiron.
		iTamanoTrozo=iTamanoFicheroOrigen;
	end
	if (iTamanoTrozo>5000000) //Menor de 5Mb lo leo a trozos de 5 Mb.
		iTamanoTrozo=5000000;
	end
	pbBuffer=alloc(iTamanoTrozo);
	// Si alloc=0 ERROR
	if (pbBuffer==0)
		write(0,0,0,0,"Error allocando memoria, ESC para salir");
		while(!jkeys_state[_JKEY_MENU]) frame; end
		exit();
	end
	while (iValor<iTamanoFicheroOrigen)
		if ((iValor+iTamanoTrozo)<iTamanoFicheroOrigen)
			iLongRead=fread(pbBuffer,iTamanoTrozo,iIdeFicheroOrigen);
			if (iLongRead==0 and iTamanoFicheroOrigen!=0)
				VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error");
				return 0;
			end
			iLongWrite=fwrite(pbBuffer,iTamanoTrozo,iIdeFicheroDestino);
			if (iLongWrite==0 and iTamanoFicheroOrigen!=0)
				VentanaMensaje(0,0,0,0,0,&sMensajeDestino,2,"Error");
				return 0;
			end
			iValor=iValor+iTamanoTrozo;
			dValorParcialDestino=dValorParcialDestino+iTamanoTrozo;
		else
			iLongRead=fread(pbBuffer,iTamanoFicheroOrigen-iValor,iIdeFicheroOrigen);
			if (iLongRead==0 and iTamanoFicheroOrigen!=0)
				VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error");
				return 0;
			end
			iLongWrite=fwrite(pbBuffer,iTamanoFicheroOrigen-iValor,iIdeFicheroDestino);
			if (iLongWrite==0 and iTamanoFicheroOrigen!=0)
				VentanaMensaje(0,0,0,0,0,&sMensajeDestino,2,"Error");
				return 0;
			end
			dValorParcialDestino=dValorParcialDestino+iTamanoFicheroOrigen-iValor;
			iValor=iTamanoFicheroOrigen;
		end	
		dValorOrigen=(iValor*100)/iTamanoFicheroOrigen; //Actualizamos por si hay una barra de progreso.
		if(dValorParcialDestino >1024 )
			dValorDestino=(((dValorParcialDestino/1024)*dcien)/(dValorTotalDestino/1024));
			//Divido por 1024 porque se me desborda el dword.
		else
			dValorDestino=(((dValorParcialDestino)*dcien)/(dValorTotalDestino));
		end
		frame;
		
	end
	fclose(iIdeFicheroOrigen);
	fclose(iIdeFicheroDestino);
	free(pbBuffer);
	return 1;
end			

//--------------------------------------------------------------------------------------
process VentanaProgresoCopia(int iX, int iY, int iAncho, int iAlto, int iAnchoMarco, int iDrawingZ, int iTextZ)
// Muestra una ventana con dos barras con el progreso de la copia.
//iX, coordenada X, si cero, centrado.
//iY, coordenada Y, si cero, centrado.
//iAncho. Ancho de la ventana. Si cero, de acuerdo con el texto.
//iAlto. Alto de la ventana. Si cero, de acuerdo con el texto.

//Varibles de uso global:
// dword dValorOrigen;			// Valor a mostrar en la barra Origen de 0 a 100.
// dword dValorDestino;			// Valor a mostrar en la barra Destino de 0 a 100.

// string sProgresoOrigen; 		// Variable que contiene el texto de la primera barra.
// string sProgresoDestino; 	// Variable que contiene el texto de la segunda barra.

// byte bAbortar=0;				// Si 1 se aborta el proceso de copia.

private
	string sVentanaMensaje[0]="";
	boton iIdeBotonCancelar;
	MarcoVentana iIdeMarcoVentana;
	string sBotonCancelar[0]="Cancel";
	int bLineas=4;

	int iIdeTexto[50];
	byte bContador;
	byte bSiNo=0;
	
	dword dValorOrigenAntiguo=0;
	dword dValorDestinoAntiguo=0;
end

begin
	iTextZ=iTextZ-240;
	iDrawingZZ=iDrawingZZ-200;
	drawing_z(iDrawingZZ);
	text_z=iTextZ;
	while (!bRepintar)
		frame;
	end
	bRepintar=0;
	
	//signal(ALL_PROCESS,s_freeze);
	frame;
	if (iAnchoMarco==0)
		iAnchoMarco=4;
	end
	if (iX==0)
		iX=iAnchoMarco;
	end
	if (iAncho==0)
		iAncho=320-iAnchoMarco*2;
	end
	if (iAlto==0)
		iAlto=20+(bLineas+2)*15;
	end
	if (iY==0)
		iY=(240-iAnchoMarco*2-iAlto)/2;
	end

	iIdeMarcoVentana=MarcoVentana(iX, iY, iAncho, iAlto, iAnchoMarco, "Processing...");
	frame;
	iIdeBotonCancelar=boton((iAncho-2),20-2,&sBotonCancelar,1,0,4,rgb(212,208,200),0,7,0, iDrawingZZ-25, iTextZ-25);
	iIdeBotonCancelar.iX=iX+2;
	iIdeBotonCancelar.iY=iY+2+iAlto-20;
	iIdeBotonCancelar.bRepintar=1;
	iIdeTexto[0]=write_var(0,iX+iAnchoMarco+5,iY+iAnchoMarco+12,0,sProgresoOrigen);
	iIdeTexto[1]=write_var(0,iX+iAnchoMarco+5,iY+iAnchoMarco+50,0,sProgresoDestino);
	iBarraOrigen=Barra(iX+iAnchoMarco+2,iAncho-iAnchoMarco*2-4,iY+iAnchoMarco+22,20,iDrawingZZ-100, iTextZ-50);
	iBarraDestino=Barra(iX+iAnchoMarco+2,iAncho-iAnchoMarco*2-4,iY+iAnchoMarco+60,20,iDrawingZZ-100, iTextZ-50);
	iBarraOrigen.bRepintar=1;
	iBarraDestino.bRepintar=1;
	frame;

	while (!bAbortar)
		if (iIdeBotonCancelar.bPulsado)
			while (iIdeBotonCancelar.bPulsado)
				frame;
			end;
			sVentanaMensaje[0]="Abort, are you sure?";
			bSiNo=VentanaSiNo(0,0,0,0,0,&sVentanaMensaje,1,"");
			if (bSiNo)
				bAbortar=1;
			end
		end
		
		if (dValorOrigenAntiguo!=dValorOrigen)
			dValorOrigenAntiguo=dValorOrigen;
			iBarraOrigen.iValor=dValorOrigen;
		end
		if (dvalorDestinoAntiguo!=dValorDestino)
			dValorDestinoAntiguo=dValorDestino;
			iBarraDestino.iValor=dValorDestino;
		end
		frame;
	end;
OnExit
	if (exists(iIdeMarcoVentana))
		signal(iIdeMarcoVentana,s_kill_tree);
	end
	if (exists(iIdeBotonCancelar))
		signal(iIdeBotonCancelar,s_Kill_tree);
	end
	if (exists(iBarraOrigen))
		signal(iBarraOrigen,s_Kill_tree);
	end
	if (exists(iBarraDestino))
		signal(iBarraDestino,s_Kill_tree);
	end
	delete_text(iIdeTexto[0]);
	delete_text(iIdeTexto[1]);
	frame;
	//signal(ALL_PROCESS,s_wakeup);
	return;
end
//------------------------------------------------------------------------------
process Barra(int iX, int iAncho, int iY, int iAlto, int iDrawingZ, int iTextZ)
//Dibuja una barra %.
//Repinta si se le pide mediante la variable bRepintar o si cambia su valor.

local
	// iValor: Valor de la barra de 0 a 100.
end
private
	int iIde[30]=0;
	int bContador;
	int iValorAntiguo=0;
end
begin
	drawing_z(iDrawingZ);
	text_z=iTextZ-10;

	drawing_color(rgb(255,255,255));
	iIde[0]=draw_line(iX,iY+iAlto,iX+iAncho,iY+iAlto);
	iIde[1]=draw_line(iX+iAncho,iY,iX+iAncho,iY+iAlto);
	drawing_color(rgb(0,0,0));
	iIde[2]=draw_line(iX,iY,iX+iAncho,iY);
	iIde[3]=draw_line(iX,iY,iX,iY+iAlto);
	drawing_color(rgb(100,100,100));
	iIde[4]=draw_line(iX,iY+1,iX+iAncho,iY+1);
	iIde[5]=draw_line(iX+1,iY,iX+1,iY+iAlto);
	drawing_color(rgb(240,240,240));
	iIde[6]=draw_box(iX+1,iY+1,iX+iAncho-1,iY+iAlto-1);
	set_text_color(rgb(150,150,255));
	iIde[8]=write_var(0,iX+iAncho/2,iY+iAlto/2,4,iValor);
	set_text_color(rgb(0,0,0));
	while (!bRepintar)
		frame;
	end
	
	loop
		bRepintar=0;
		drawing_z(iDrawingZ-10);
		drawing_color(rgb(0,0,255));
		iIde[7]=draw_box(iX+2,iY+2,iX+2+(iValor*(iAncho-4)/100),iY+iAlto-2);
		iValorAntiguo=iValor;
		while ((!bRepintar) and (iValor==iValorAntiguo))
			frame;
		end
		delete_draw(iIde[7]);
		iIde[7]=0;
	end
OnExit
	bContador=0;
	while (bContador<=7)
		if (iIde[bContador]!=0)
			delete_draw(iIde[bContador]);
		end
		bContador++;
	end
	delete_text(iIde[8]);

end
//--------------------------------------------------------------------------------------
function byte VentanaFicheroExiste(	string sFicheroOrigenA, string sFicheroOrigenB, string sFicheroOrigenC
									string sFicheroDestinoA, string sFicheroDestinoB, string sFicheroDestinoC)
//Cuando el fichero existe da a elegir las siguientes opciones:
//1 - Overwrite
//2 - Overwrite all
//3 - Overwrite all older
//4 - Skip
//5 - Skip all
//6 - Cancel
//Devuelve el nmero de opcin elegida.
private
	boton iBotonOverwrite;
	boton iBotonOverwriteAll;
	boton iBotonOverwriteAllOlder;
	boton iBotonSkip;
	boton iBotonSkipAll;
	boton iBotonCancel;
	MarcoVentana iIdeMarcoVentana;
	string sOverwrite[0]="Overwrite";
	string sOverwriteAll[0]="Overwrite all";
	string sOverwriteAllOlder[0]="Overw all older";
	string sSkip[0]="Skip";
	string sSkipAll[0]="Skip all";
	string sCancel[0]="Cancel";
	int bLineas=1;

	int iIdeTexto[50];
	byte bContador;
	int iAnchoMarco=0;
	int iAncho=0;
	int iAlto=0;
	byte bFila;
	byte bInicioFila;
	byte bAnchoBoton;
	byte bSalida=0;
end

begin
	iX=0;
	iY=0;
	iTextZ=iTextZ-1000;
	iDrawingZZ=iDrawingZZ-1000;
	drawing_z(iDrawingZZ);
	text_z=iTextZ;
	signal(ALL_PROCESS,s_freeze);
	frame;
	bRepintar=0;
	
	frame;
	if (iAnchoMarco==0)
		iAnchoMarco=4;
	end
	if (iX==0)
		iX=iAnchoMarco;
	end
	if (iAncho==0)
		iAncho=320-iAnchoMarco*2;
	end
	if (iAlto==0)
		iAlto=40+(bLineas+4)*20;
	end
	if (iY==0)
		iY=(240-iAnchoMarco*2-iAlto)/2;
	end

	
	iIdeMarcoVentana=MarcoVentana(iX, iY, iAncho, iAlto, iAnchoMarco, "Repeat file");
	frame;
	drawing_z(iDrawingZZ+100);
	text_z=iTextZ+100;

	bFila=iY+2+iAlto-38;
	bInicioFila=iAnchoMarco+2;
	bAnchoBoton=103;

	iBotonOverwrite=boton(bAnchoBoton,20-2,&sOverwrite,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-25, iTextZ-25);
	iBotonOverwrite.iX=bInicioFila;
	iBotonOverwrite.iY=bFila;
	iBotonOverwrite.bRepintar=1;

	bInicioFila=bInicioFila+bAnchoBoton;
	iBotonOverwriteAll=boton(bAnchoBoton,20-2,&sOverwriteAll,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-25, iTextZ-25);
	iBotonOverwriteAll.iX=bInicioFila;
	iBotonOverwriteAll.iY=bFila;
	iBotonOverwriteAll.bRepintar=1;

	bInicioFila=bInicioFila+bAnchoBoton;
	iBotonOverwriteAllOlder=boton(bAnchoBoton,20-2,&sOverwriteAllOlder,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-25, iTextZ-25);
	iBotonOverwriteAllOlder.iX=bInicioFila;
	iBotonOverwriteAllOlder.iY=bFila;
	iBotonOverwriteAllOlder.bRepintar=1;

	bFila=iY+2+iAlto-20;
	bInicioFila=iAnchoMarco+2;
	iBotonSkip=boton(bAnchoBoton,20-2,&sSkip,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-25, iTextZ-25);
	iBotonSkip.iX=bInicioFila;
	iBotonSkip.iY=bFila;
	iBotonSkip.bRepintar=1;

	bInicioFila=bInicioFila+bAnchoBoton;
	iBotonSkipAll=boton(bAnchoBoton,20-2,&sSkipAll,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-25, iTextZ-25);
	iBotonSkipAll.iX=bInicioFila;
	iBotonSkipAll.iY=bFila;
	iBotonSkipAll.bRepintar=1;

	bInicioFila=bInicioFila+bAnchoBoton;
	iBotonCancel=boton(bAnchoBoton,20-2,&sCancel,1,iFuenteBlack,4,rgb(212,208,200),0,2,0, iDrawingZZ-25, iTextZ-25);
	iBotonCancel.iX=bInicioFila;
	iBotonCancel.iY=bFila;
	iBotonCancel.bRepintar=1;

	
	iIdeTexto[0]=write(iFuenteBlack,iX+iAnchoMarco+5,iY+iAnchoMarco+10,0,"Overwrite:");

//	set_text_color(rgb(255,0,0));
	iIdeTexto[1]=write(iFuenteRed,iX+iAnchoMarco+5,iY+iAnchoMarco+10+10,0,sFicheroOrigenA);
	iIdeTexto[2]=write(iFuenteRed,iX+iAnchoMarco+5,iY+iAnchoMarco+10+20,0,sFicheroOrigenB);
	iIdeTexto[3]=write(iFuenteRed,iX+iAnchoMarco+5,iY+iAnchoMarco+10+30,0,sFicheroOrigenC);

//	set_text_color(rgb(0,0,0));
	iIdeTexto[4]=write(iFuenteBlack,iX+iAnchoMarco+5,iY+iAnchoMarco+15+40,0,"With file:");

//	set_text_color(rgb(255,0,0));
	iIdeTexto[5]=write(iFuenteRed,iX+iAnchoMarco+5,iY+iAnchoMarco+15+50,0,sFicheroDestinoA);
	iIdeTexto[6]=write(iFuenteRed,iX+iAnchoMarco+5,iY+iAnchoMarco+15+60,0,sFicheroDestinoB);
	iIdeTexto[7]=write(iFuenteRed,iX+iAnchoMarco+5,iY+iAnchoMarco+15+70,0,sFicheroDestinoC);
//	set_text_color(rgb(0,0,0));



	frame;
	while (!bSalida)
		frame;
		if (iBotonOverwrite.bPulsado)
			bSalida=1;
			while (iBotonOverwrite.bPulsado)
				frame;
			end;
		end
		if (iBotonOverwriteAll.bPulsado)
			bSalida=2;
			while (iBotonOverwriteAll.bPulsado)
				frame;
			end;
		end
		if (iBotonOverwriteAllOlder.bPulsado)
			bSalida=3;
			while (iBotonOverwriteAllOlder.bPulsado)
				frame;
			end;
		end
		if (iBotonSkip.bPulsado)
			bSalida=4;
			while (iBotonSkip.bPulsado)
				frame;
			end;
		end
		if (iBotonSkipAll.bPulsado)
			bSalida=5;
			while (iBotonSkipAll.bPulsado)
				frame;
			end;
		end
		if (iBotonCancel.bPulsado)
			bSalida=6;
			while (iBotonCancel.bPulsado)
				frame;
			end;
		end
	end;

	signal(ALL_PROCESS,s_wakeup);
	frame;
	
	if (exists(iIdeMarcoVentana))
		signal(iIdeMarcoVentana,s_kill_tree);
	end
	if (exists(iBotonOverwrite))
		signal(iBotonOverwrite,s_kill_tree);
	end
	if (exists(iBotonOverwriteAll))
		signal(iBotonOverwriteAll,s_kill_tree);
	end
	if (exists(iBotonOverwriteAllOlder))
		signal(iBotonOverwriteAllOlder,s_kill_tree);
	end
	if (exists(iBotonSkip))
		signal(iBotonSkip,s_kill_tree);
	end
	if (exists(iBotonSkipAll))
		signal(iBotonSkipAll,s_kill_tree);
	end
	if (exists(iBotonCancel))
		signal(iBotonCancel,s_kill_tree);
	end
	bContador=0;
	while (bContador<8)
		delete_text(iIdeTexto[bContador]);
		bContador++;
	end

	iTextZ=iTextZ+1000;
	iDrawingZZ=iDrawingZZ+1000;
	drawing_z(iDrawingZZ);
	text_z=iTextZ;

	frame;
	return bSalida;
end

//--------------------------------------------------------------------------------------
