//------------------------------------------------------------------------------
function byte KeyPausa(int iScanCode)
// Funcin que simula la pulsacin de las teclas con pausa al estilo teclado.
// Necesita las siguientes variables globales:
// iUltimaTeclaPulsada=0; // Ultima tecla pulsada.
// iTiempoSinPulsar=0; // Si pasa demasiado tiempo sin pulsar.
// Devuelve 1 si la tecla est pulsada y no est en la pausa inter tecla.

private
	int iDiferencia;
	int iTiempo=0;
end


begin
	iTiempo=timer[0];
	if (iUltimaTeclaPulsada==iScanCode and !jKeys_state[iScanCode]) //Se solt la ltima tecla.
		iUltimaTeclaPulsada=-1;
		return 0;
	end
	if (jKeys_state[iScanCode] and iUltimaTeclaPulsada==iScanCode and iTiempo<30) //Se sigue pulsando la tecla, pero hay que esperar.
		iTiempoSinPulsar=iTiempo;
		return 0;
	end
	if (jKeys_state[iScanCode] and iUltimaTeclaPulsada==iScanCode and iTiempo>30) //Se sigue pulsando la tecla tras la pausa.
		return 1;
	end
	if (jKeys_state[iScanCode] and iUltimaTeclaPulsada!=iScanCode) //Se ha pulsado la tecla por primera vez.
		iUltimaTeclaPulsada=iScanCode;
		timer[0]=0;
		iTiempoSinPulsar=0;
		return 1;
	end
	return 0;
end
//------------------------------------------------------------------------------
process raton();
begin
	signal_action(s_freeze,S_IGN);
	frame;
	if(os_id!=OS_GP2X_WIZ and os_id!=OS_CAANOO)
		graph=1;
	end
	loop
		x=mouse.x;
		y=mouse.y;
		z=z-500;
		frame;
	end
end
//--------------------------------------------------------------------------------------
process Salida();
begin
	signal_action(s_freeze,S_IGN);
	frame;
	while (jkeys[ _JKEY_MENU ])
		frame;
	end
	exit();
end
//--------------------------------------------------------------------------------------
function jkeys_set_default_keys()
begin
	jkeys[ _JKEY_UP ] = _UP ;
	jkeys[ _JKEY_UPLEFT ] = 0 ;
	jkeys[ _JKEY_LEFT ] = _LEFT ;
	jkeys[ _JKEY_DOWNLEFT ] = 0 ;
	jkeys[ _JKEY_DOWN ] = _DOWN ;
	jkeys[ _JKEY_DOWNRIGHT ] = 0 ;
	jkeys[ _JKEY_RIGHT ] = _RIGHT ;
	jkeys[ _JKEY_UPRIGHT ] = 0 ;
	jkeys[ _JKEY_MENU ] = _ESC ;
	jkeys[ _JKEY_SELECT ] = 0 ;
	jkeys[ _JKEY_L ] = _O ;
	jkeys[ _JKEY_R ] = _P ;
	jkeys[ _JKEY_A ] = _A ;
	jkeys[ _JKEY_B ] = _ENTER ;
	jkeys[ _JKEY_X ] = _BACKSPACE;
	jkeys[ _JKEY_Y ] = _W ;
	jkeys[ _JKEY_VOLUP ] = 0 ;
	jkeys[ _JKEY_VOLDOWN ] = 0 ;
	jkeys[ _JKEY_CLICK ] = 0 ;
end
/* -------------------------------------------------------------------------- */
process jkeys_controller()
private
	i;
begin
	signal_action(s_freeze,S_IGN);
	frame;
	signal_action( s_kill, s_ign );
	frame;
	signal( type jkeys_controller, s_kill );
	frame;
	signal_action( s_kill, s_dfl );
	loop
		for ( i = 0; i < _JKEY_LAST; i++ )
		if ( jkeys[i] )
			jkeys_state[i] = key( jkeys[i] );
		else
			jkeys_state[i] = 0;
		end
	end
	if ( os_id == OS_GP2X_WIZ && joy_number() ) /* Wiz */
		jkeys_state[ _JKEY_UP ] |= joy_getbutton( 0, _JKEY_UP );
		jkeys_state[ _JKEY_UPLEFT ] |= joy_getbutton( 0, _JKEY_UPLEFT );
		jkeys_state[ _JKEY_LEFT ] |= joy_getbutton( 0, _JKEY_LEFT );
		jkeys_state[ _JKEY_DOWNLEFT ] |= joy_getbutton( 0, _JKEY_DOWNLEFT );
		jkeys_state[ _JKEY_DOWN ] |= joy_getbutton( 0, _JKEY_DOWN );
		jkeys_state[ _JKEY_DOWNRIGHT ] |= joy_getbutton( 0, _JKEY_DOWNRIGHT );
		jkeys_state[ _JKEY_RIGHT ] |= joy_getbutton( 0, _JKEY_RIGHT );
		jkeys_state[ _JKEY_UPRIGHT ] |= joy_getbutton( 0, _JKEY_UPRIGHT );
		jkeys_state[ _JKEY_MENU ] |= joy_getbutton( 0, _JKEY_MENU );
		jkeys_state[ _JKEY_SELECT ] |= joy_getbutton( 0, _JKEY_SELECT );
		jkeys_state[ _JKEY_L ] |= joy_getbutton( 0, _JKEY_L );
		jkeys_state[ _JKEY_R ] |= joy_getbutton( 0, _JKEY_R );
		jkeys_state[ _JKEY_A ] |= joy_getbutton( 0, _JKEY_A );
		jkeys_state[ _JKEY_B ] |= joy_getbutton( 0, _JKEY_B );
		jkeys_state[ _JKEY_X ] |= joy_getbutton( 0, _JKEY_X );
		jkeys_state[ _JKEY_Y ] |= joy_getbutton( 0, _JKEY_Y );
		jkeys_state[ _JKEY_VOLUP ] |= joy_getbutton( 0, _JKEY_VOLUP );
		jkeys_state[ _JKEY_VOLDOWN ] |= joy_getbutton( 0, _JKEY_VOLDOWN );
		jkeys_state[ _JKEY_CLICK ] |= joy_getbutton( 0, _JKEY_CLICK );
		jkeys_state[_JKEY_UP ] |= jkeys_state[ _JKEY_UPLEFT ] | jkeys_state[ _JKEY_UPRIGHT ];
		jkeys_state[_JKEY_DOWN]|= jkeys_state[_JKEY_DOWNRIGHT ] | jkeys_state[ _JKEY_DOWNLEFT ];
		jkeys_state[_JKEY_LEFT ] |= jkeys_state[ _JKEY_UPLEFT ] | jkeys_state[ _JKEY_DOWNLEFT ];
		jkeys_state[_JKEY_RIGHT] |= jkeys_state[ _JKEY_UPRIGHT ]| jkeys_state[ _JKEY_DOWNRIGHT ];
	end
	frame;
	end
end
//--------------------------------------------------------------------------------------
process jkeys_init()
private
    i;
#if 0
    axis_x, axis_y;
#endif
begin
	signal_action(s_freeze,S_IGN);
    signal_action( s_kill, s_ign );
    signal( type jkeys_init, s_kill );
    signal_action( s_kill, s_dfl );

    priority = 999999;

    loop
        for ( i = 0; i < _JKEY_LAST; i++ )
            if ( jkeys[i] )
                jkeys_state[i] = key( jkeys[i] );
            else
                jkeys_state[i] = 0;
            end
        end

        switch ( os_id )
            case    OS_GP2X_WIZ, OS_CAANOO: /* Wiz */
                    jkeys_state[ _JKEY_UP        ] |= joy_getbutton( 0, _JKEY_UP        );
                    jkeys_state[ _JKEY_UPLEFT    ] |= joy_getbutton( 0, _JKEY_UPLEFT    );
                    jkeys_state[ _JKEY_LEFT      ] |= joy_getbutton( 0, _JKEY_LEFT      );
                    jkeys_state[ _JKEY_DOWNLEFT  ] |= joy_getbutton( 0, _JKEY_DOWNLEFT  );
                    jkeys_state[ _JKEY_DOWN      ] |= joy_getbutton( 0, _JKEY_DOWN      );
                    jkeys_state[ _JKEY_DOWNRIGHT ] |= joy_getbutton( 0, _JKEY_DOWNRIGHT );
                    jkeys_state[ _JKEY_RIGHT     ] |= joy_getbutton( 0, _JKEY_RIGHT     );
                    jkeys_state[ _JKEY_UPRIGHT   ] |= joy_getbutton( 0, _JKEY_UPRIGHT   );
                    jkeys_state[ _JKEY_MENU      ] |= joy_getbutton( 0, _JKEY_MENU      );
                    jkeys_state[ _JKEY_SELECT    ] |= joy_getbutton( 0, _JKEY_SELECT    );
                    jkeys_state[ _JKEY_L         ] |= joy_getbutton( 0, _JKEY_L         );
                    jkeys_state[ _JKEY_R         ] |= joy_getbutton( 0, _JKEY_R         );
                    jkeys_state[ _JKEY_A         ] |= joy_getbutton( 0, _JKEY_A         );
                    jkeys_state[ _JKEY_B         ] |= joy_getbutton( 0, _JKEY_B         );
                    jkeys_state[ _JKEY_X         ] |= joy_getbutton( 0, _JKEY_X         );
                    jkeys_state[ _JKEY_Y         ] |= joy_getbutton( 0, _JKEY_Y         );
                    jkeys_state[ _JKEY_VOLUP     ] |= joy_getbutton( 0, _JKEY_VOLUP     );
                    jkeys_state[ _JKEY_VOLDOWN   ] |= joy_getbutton( 0, _JKEY_VOLDOWN   );
                    jkeys_state[ _JKEY_CLICK     ] |= joy_getbutton( 0, _JKEY_CLICK     );

                    jkeys_state[ _JKEY_UP        ] |= jkeys_state[ _JKEY_UPLEFT    ] | jkeys_state[ _JKEY_UPRIGHT   ] ;
                    jkeys_state[ _JKEY_DOWN      ] |= jkeys_state[ _JKEY_DOWNRIGHT ] | jkeys_state[ _JKEY_DOWNLEFT  ] ;
                    jkeys_state[ _JKEY_LEFT      ] |= jkeys_state[ _JKEY_UPLEFT    ] | jkeys_state[ _JKEY_DOWNLEFT  ] ;
                    jkeys_state[ _JKEY_RIGHT     ] |= jkeys_state[ _JKEY_UPRIGHT   ] | jkeys_state[ _JKEY_DOWNRIGHT ] ;
            end

#if 0
            case    OS_CAANOO: /* Caanoo */

                    axis_x = joy_getaxis( 2, 0 );
                    axis_y = joy_getaxis( 2, 1 );

                    jkeys_state[ _JKEY_UP        ] |= ( axis_y < -16384 );
                    jkeys_state[ _JKEY_UPLEFT    ] |= ( axis_y < -16384 ) && ( axis_x < -16384 );
                    jkeys_state[ _JKEY_LEFT      ] |=                        ( axis_x < -16384 );
                    jkeys_state[ _JKEY_DOWNLEFT  ] |= ( axis_y >  16384 ) && ( axis_x < -16384 );
                    jkeys_state[ _JKEY_DOWN      ] |= ( axis_y >  16384 );
                    jkeys_state[ _JKEY_DOWNRIGHT ] |= ( axis_y >  16384 ) && ( axis_x > 16384 );
                    jkeys_state[ _JKEY_RIGHT     ] |=                        ( axis_x > 16384 );
                    jkeys_state[ _JKEY_UPRIGHT   ] |= ( axis_y < -16384 ) && ( axis_x > 16384 );
                    jkeys_state[ _JKEY_MENU      ] |= joy_getbutton( 0, _JKEY_MENU      );
                    jkeys_state[ _JKEY_SELECT    ] |= joy_getbutton( 0, _JKEY_SELECT    );
                    jkeys_state[ _JKEY_L         ] |= joy_getbutton( 0, _JKEY_L         );
                    jkeys_state[ _JKEY_R         ] |= joy_getbutton( 0, _JKEY_R         );
                    jkeys_state[ _JKEY_A         ] |= joy_getbutton( 0, _JKEY_A         );
                    jkeys_state[ _JKEY_B         ] |= joy_getbutton( 0, _JKEY_B         );
                    jkeys_state[ _JKEY_X         ] |= joy_getbutton( 0, _JKEY_X         );
                    jkeys_state[ _JKEY_Y         ] |= joy_getbutton( 0, _JKEY_Y         );
                    jkeys_state[ _JKEY_VOLUP     ] |= joy_getbutton( 0, _JKEY_VOLUP     );
                    jkeys_state[ _JKEY_VOLDOWN   ] |= joy_getbutton( 0, _JKEY_VOLDOWN   );
                    jkeys_state[ _JKEY_CLICK     ] |= joy_getbutton( 0, _JKEY_CLICK     );

                    jkeys_state[ _JKEY_UP        ] |= jkeys_state[ _JKEY_UPLEFT    ] | jkeys_state[ _JKEY_UPRIGHT   ] ;
                    jkeys_state[ _JKEY_DOWN      ] |= jkeys_state[ _JKEY_DOWNRIGHT ] | jkeys_state[ _JKEY_DOWNLEFT  ] ;
                    jkeys_state[ _JKEY_LEFT      ] |= jkeys_state[ _JKEY_UPLEFT    ] | jkeys_state[ _JKEY_DOWNLEFT  ] ;
                    jkeys_state[ _JKEY_RIGHT     ] |= jkeys_state[ _JKEY_UPRIGHT   ] | jkeys_state[ _JKEY_DOWNRIGHT ] ;
            end
#endif
        end

        frame;
    end

onexit:
    if ( !_jkeys_exit && !_jkeys_old_version ) jkeys_init(); end

end

/* -------------------------------------------------------------------------- */

function jkeys_exit()
begin
	signal_action(s_freeze,S_IGN);
    _jkeys_exit = 1;
    signal( type jkeys_init, s_kill );
end

/* -------------------------------------------------------------------------- */
//--------------------------------------------------------------------------------------
function Pausa()
// Espera a que pulsemos una tecla	
private 
end

begin
	while (!jkeys_state[ _JKEY_Y ]) frame; end
	while (jkeys_state[ _JKEY_Y ]) frame; end;
end
//--------------------------------------------------------------------------------------
function string iTos(int iNumero)
// Devuelve el int dado en string formateado con puntos.
private
	int iLongitud=0;
	string sCadena="";
	string sResultado="";
	byte bContador=0;
end

begin
	sCadena=itoa(iNumero);
	iLongitud=len(sCadena);
	bContador=iLongitud;
	while (bContador>0)
		sResultado=sCadena[bContador-1]+sResultado;

		if((bContador-1==iLongitud-3)and(iLongitud>3))
			sResultado="."+sResultado;
		end
		if((bContador-1==iLongitud-6)and(iLongitud>6))
			sResultado="."+sResultado;
		end
		if((bContador-1==iLongitud-9)and(iLongitud>9))
			sResultado="."+sResultado;
		end

		bContador--;
	end
	return (sResultado);
end
//--------------------------------------------------------------------------------------
function byte MiFexists(string sDirectorio,string sFichero)
// Devuelve '1' si el fichero existe. '0' en caso contrario.
// Si el fichero existe, se actualiza fileinfo.
// No distingue entre maysculas y minsculas.
private
	string sDirectorioEnCurso="";
	string sArchivo;
end
begin
	sDirectorioEnCurso=cd();
	chdir(sDirectorio);
	sArchivo=glob("");
	sArchivo=glob("*.*");
	while (sArchivo!="")
		if (ucase(sArchivo)==ucase(sFichero) and fileinfo.directory==0)
			chdir(sDirectorioEnCurso);
			return 1;
		end
		sArchivo=glob("*.*");
	end
	chdir(sDirectorioEnCurso);
	return 0;
end
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------


