//------------------------------------------------------------------------------
process Boton(int iAncho, int iAlto, string pointer sTexto, byte bLineas,
			   int iFuente, byte bJustificacion, dword dColor_Boton, dword dColor_Texto, byte bSeparacion,
			   int iGraph, int iDrawingZ, int iTextZ)
/*
Funcin que dibuja un botn en la pantalla con estado on/off.

iX: 	Coordenada X.
iAncho:	Ancho del botn. 0-automtico.
iY:		Coordenada Y.
iAlto:	Alto del botn. 0-automtico.
sTexto[]:	Texto del botn. Cada lnea independiente.
bLineas:	Cantidad de lineas pasadas. (mximo 63).
iFuente: Fuente del texto. 0-La del sistema.
bJustificacion: Justificacin del texto: 3-Izquierda, 4-Centro, 5-Derecha. La misma que write.
dColor_Boton:	Color del botn. 0-Gris por defecto.
dColor_Texto:	Color del texto. 0-Negro por defecto.
bSeparacion: Espacio en pxeles alrederor del texto.
iGraph:	N del grfico a dibujar. (0-No hay).
bRepintar: 1-Repinta.
bPulsado: 1-El botn fue pulsado.
*/

private
	int iAncho_Texto_Mayor=0; // Contendr el ancho del texto a mostrar.
	int iAlto_Texto_Total=0;  // Contanedr el alto del texto a mostrar.
	int iAncho_Texto;		// Ancho de lnea en curso.
	int iAlto_Texto;		// Alto de la lnea en curso.
	int iIde[70]=0;  // Array de identificadores de los objetos que usamos para dibujar el botn.
	int iCentrado=0;
	byte bContador=0;  // Contador de usos mltiples.
	Grafico iIde_Grafico=0; //Identificador del proceso que dibuja un grfico.
	int iAncho_Grafico=0;  //Ancho del grfico.
	byte bFocus=0; //Si estoy encima del boton: bFocus=1.
	int iTz=0;
end

begin
	iTz=iTextZ;
	if (iAncho>0)
		iAncho--;
	end
	if (iAlto>0)
		iAlto--;
	end

	drawing_z(iDrawingZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
	text_z=iTZ;
	//Espero Inicializacion.
	while (bRepintar==0)
		frame;
	end
	bRepintar=0;
	loop
		drawing_z(iDrawingZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
		text_z=iTZ-1;
		// Inicializando varables por defecto.
		iAncho_Texto_Mayor=0;
		iAlto_Texto=Text_height(iFuente,"Pruebag");
		iAlto_Texto_Total=iAlto_Texto*bLineas;
		bContador=0;
		//Analizando tamao del texto en el botn.
		while (bContador<bLineas)
			iAncho_Texto=Text_width(iFuente, sTexto[bContador]);
			if(iAncho_Texto_Mayor<iAncho_Texto)
				iAncho_Texto_Mayor=iAncho_Texto;
			end
			bcontador++;
		end
		if (iAncho==0)
			iAncho=iAncho_Texto_Mayor+bSeparacion*2;
		end
		if (iAlto==0)
			iAlto=iAlto_Texto_Total+bSeparacion*2;
		end
		if (dColor_Boton==0)
			dColor_Boton=rgb(190,190,190);
		end
		if (dColor_Texto==0)
			dColor_Texto=rgb(0,0,0);
		end
		if(iAncho>iAlto)
			iAncho_Grafico=iAlto;
		else
			iAncho_Grafico=iAncho;
		end
		if(iGraph>0)
			if(exists(iIde_Grafico))
				iIde_Grafico.X=iX+iAncho/2+1;
				iIde_Grafico.Y=iY+iAlto/2+1;
				iIde_Grafico.Angle=Angle;
				if (bScala)
					iIde_Grafico.size=(iAncho_Grafico/2)*100/50;
				end
			else
				iIde_Grafico=Grafico(iX+iAncho/2+1, iY+iAlto/2+1, 100, iGraph, iDrawingZ);
				iIde_Grafico.Angle=Angle;
				if (bScala)
					iIde_Grafico.size=(iAncho_Grafico/2)*100/50;
				end
			end
		end
		drawing_z(iDrawingZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
		if (bPulsado==0)
			drawing_color(rgb(0,0,0));
			iIde[0]=draw_line(iX,iY+iAlto,iX+iAncho,iY+iAlto);
			iIde[1]=draw_line(iX+iAncho,iY,iX+iAncho,iY+iAlto);
			drawing_color(rgb(255,255,255));
			iIde[2]=draw_line(iX,iY,iX+iAncho,iY);
			iIde[3]=draw_line(iX,iY,iX,iY+iAlto);
			drawing_color(rgb(100,100,100));
			iIde[4]=draw_line(iX,iY+iAlto-1,iX+iAncho,iY+iAlto-1);
			iIde[5]=draw_line(iX+iAncho-1,iY,iX+iAncho-1,iY+iAlto);
			drawing_color(dColor_Boton);
			iIde[6]=draw_box(iX+1,iY+1,iX+iAncho-2,iY+iAlto-2);
			set_text_color(dColor_Texto);
			if(bJustificacion==3)
				iCentrado=0;
			end
			if(bJustificacion==4)
				//iCentrado=iAncho/2-iAncho_Texto_Mayor/2;
				iCentrado=iAncho/2-bSeparacion;
			end
			if(bJustificacion==5)
				iCentrado=iAncho_Texto_Mayor;
			end
			bContador=0;
			while(bContador<bLineas)
				iIde[7+bContador]=write(iFuente,iX+bSeparacion+1+iCentrado,iAlto_Texto*(bContador+1)+iY+bSeparacion-5,bJustificacion,sTexto[bContador]);
				bContador++;
			end
			if (exists(iIde_Grafico))
				iIde_Grafico.Z=iDrawingZ-5;
				iIde_Grafico.X--;
				iIde_Grafico.Y--;
				frame;
			end
		else
			drawing_color(rgb(255,255,255));
			iIde[0]=draw_line(iX,iY+iAlto,iX+iAncho,iY+iAlto);
			iIde[1]=draw_line(iX+iAncho,iY,iX+iAncho,iY+iAlto);
			drawing_color(rgb(0,0,0));
			iIde[2]=draw_line(iX,iY,iX+iAncho,iY);
			iIde[3]=draw_line(iX,iY,iX,iY+iAlto);
			drawing_color(rgb(100,100,100));
			iIde[4]=draw_line(iX,iY+1,iX+iAncho,iY+1);
			iIde[5]=draw_line(iX+1,iY,iX+1,iY+iAlto);
			drawing_color(dColor_Boton);
			iIde[6]=draw_box(iX+1,iY+1,iX+iAncho-1,iY+iAlto-1);
			set_text_color(dColor_Texto);
			if(bJustificacion==3)
				iCentrado=0;
			end
			if(bJustificacion==4)
				//iCentrado=iAncho/2-iAncho_Texto_Mayor/2;
				iCentrado=iAncho/2-bSeparacion;
			end
			if(bJustificacion==5)
				iCentrado=iAncho_Texto_Mayor;
			end
			bContador=0;
			while(bContador<bLineas)
				iIde[7+bContador]=write(iFuente,iX+bSeparacion+3+iCentrado,iAlto_Texto*(bContador+1)-3+iY+bSeparacion,bJustificacion,sTexto[bContador]);
				bContador++;
			end
			if (exists(iIde_Grafico))
				iIde_Grafico.Z=iIde_Grafico.Z-500;
				iIde_Grafico.X++;
				iIde_Grafico.Y++;
			end
		end
		//frame;
		// Mientras no manden repintar...
		if (!mouse.left and bRepintar==1)
			bRepintar=0;
		end
		while (bRepintar==0)
			if (mouse.x>iX and mouse.x<iX+iAncho and mouse.y>iY and mouse.y<iY+iAlto and mouse.left)
				bPulsado=1;
			else
				bPulsado=0;
			end
			if (bPulsado!=bFocus)
				bFocus=bPulsado;
				bRepintar=1;
			end
		
/*		
			// Proceso original que chequeaba el botn. Se cambi por problemas en la Wiz.
			if (!mouse.left and bPulsado==1)
				bPulsado=0;
				bRepintar=1;
			end
			if (mouse.x>iX and mouse.x<iX+iAncho and mouse.y>iY and mouse.y<iY+iAlto and !mouse.left)
				bFocus=1;
			end
			if (mouse.x>iX and mouse.x<iX+iAncho and mouse.y>iY and mouse.y<iY+iAlto and mouse.left
				and bFocus==1)
				bPulsado=1;
				bRepintar=1;
				bFocus=0;
			end
			if (mouse.x<iX or mouse.x>iX+iAncho or mouse.y<iY or mouse.y>iY+iAlto)
				bFocus=0;
			end
*/
			frame;
		end
		bRepintar=0;
		// Borro y repinto.
		bContador=0;
		while (bContador<=6)
			delete_draw(iIde[bContador]);
			bContador++;
		end
		bContador=0;
		while(bContador<bLineas)
			delete_text(iIde[7+bContador]);
			bContador++;
		end
	end
OnExit
		bContador=0;
		while (bContador<=6)
			delete_draw(iIde[bContador]);
			bContador++;
		end
		bContador=0;
		while(bContador<bLineas)
			delete_text(iIde[7+bContador]);
			bContador++;
		end
		if (iGraph>0)
			if (exists(iIde_Grafico))
				signal(iIde_Grafico,s_Kill_tree);
			end
		end
		frame;

end
//------------------------------------------------------------------------------
process Grafico(int iX, int iY, int iSize, int iGraph, int iDrawingZ)
/*
Funcin que dibuja el grafico en el boton.

iX: 	Coordenada X.
iY:		Coordenada Y.
iSize:	Tamao del grfico.
iGraph:	N del grfico.
*/

begin
	x=iX;
	y=iY;
	z=iDrawingZ-5;
	size=iSize;
	graph=iGraph;
	loop
		frame;
	end
end
//------------------------------------------------------------------------------
